struct vuart_config {
	unsigned int type;
	unsigned int flags;
};

struct vuart_host;
struct vuart_host_ops {
	unsigned int	(*in)(struct vuart_host *up, int offset);
	void		(*out)(struct vuart_host *up, int offset, int value);
	void		(*startup)(struct vuart_host *up);
	void		(*shutdown)(struct vuart_host *up);
	void		(*sleep)(struct vuart_host *up, int sleep);
};

struct vuart_host {
	struct vuart_host_ops	*ops;
};

int serial_v8250_register_port(struct vuart_config *conf, struct vuart_host *host);
void serial_v8250_unregister_port(int line);
unsigned int serial_v8250_interrupt(int line);

/* vtype options */
#define VUART_GENERIC	0

/* vflags */
#define	VPF_INTERRUPT	1

#define	VUART_NR	8
